diff -bruN freeswan-1.9.orig/pluto/md5.c freeswan-1.9/pluto/md5.c
--- freeswan-1.9.orig/pluto/md5.c	Sat Dec 11 20:31:36 1999
+++ freeswan-1.9/pluto/md5.c	Wed May 16 10:57:20 2001
@@ -139,7 +139,11 @@
 /* MD5 initialization. Begins an MD5 operation, writing a new context.
  */
 void MD5Init (context)
+#ifndef OPENSSL
 MD5_CTX *context;                                        /* context */
+#else
+PLUTO_MD5_CTX *context;                                  /* context */
+#endif
 {
   context->count[0] = context->count[1] = 0;
   /* Load magic initialization constants.
@@ -155,7 +159,11 @@
   context.
  */
 void MD5Update (context, input, inputLen)
+#ifndef OPENSSL
 MD5_CTX *context;                                        /* context */
+#else
+PLUTO_MD5_CTX *context;                                  /* context */
+#endif
 unsigned char *input;                                /* input block */
 UINT4 inputLen;                            /* length of input block */
 {
@@ -194,7 +202,11 @@
  */
 void MD5Final (digest, context)
 unsigned char digest[16];                         /* message digest */
+#ifndef OPENSSL
 MD5_CTX *context;                                       /* context */
+#else
+PLUTO_MD5_CTX *context;
+#endif /* OPENSSL */
 {
   unsigned char bits[8];
   unsigned int index, padLen;
diff -bruN freeswan-1.9.orig/pluto/md5.h freeswan-1.9/pluto/md5.h
--- freeswan-1.9.orig/pluto/md5.h	Sat Dec 11 20:31:36 1999
+++ freeswan-1.9/pluto/md5.h	Wed May 16 10:57:20 2001
@@ -61,11 +61,22 @@
   UINT4 state[4];                                   /* state (ABCD) */
   UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
   unsigned char buffer[64];                         /* input buffer */
+#ifndef OPENSSL
 } MD5_CTX;
+#else
+} PLUTO_MD5_CTX;
+#endif /* OPENSSL */
 
+#ifndef OPENSSL
 void MD5Init PROTO_LIST ((MD5_CTX *));
 void MD5Update PROTO_LIST
   ((MD5_CTX *, unsigned char *, UINT4));
 void MD5Final PROTO_LIST ((unsigned char [16], MD5_CTX *));
+#else
+void MD5Init PROTO_LIST ((PLUTO_MD5_CTX *));
+void MD5Update PROTO_LIST
+  ((PLUTO_MD5_CTX *, unsigned char *, unsigned int));
+void MD5Final PROTO_LIST ((unsigned char [16], PLUTO_MD5_CTX *));
+#endif /* OPENSSL */
 
 #define _MD5_H_
